"use strict";

var _interopRequireDefault = require("babel-runtime/helpers/interop-require-default")["default"];

exports.__esModule = true;

var _loose = require("./loose");

var _loose2 = _interopRequireDefault(_loose);

var _vanilla = require("./vanilla");

var _vanilla2 = _interopRequireDefault(_vanilla);

var _babelHelperFunctionName = require("babel-helper-function-name");

var _babelHelperFunctionName2 = _interopRequireDefault(_babelHelperFunctionName);

exports["default"] = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ClassDeclaration: function ClassDeclaration(path) {
        var _path = path;
        var node = _path.node;

        if (path.parentPath.isExportDefaultDeclaration()) {
          path = path.parentPath;
          path.insertAfter(t.exportDefaultDeclaration(node.id));
        }

        path.replaceWith(t.variableDeclaration("let", [t.variableDeclarator(node.id, t.toExpression(node))]));
      },

      ClassExpression: function ClassExpression(path, state) {
        var inferred = _babelHelperFunctionName2["default"](path);
        if (inferred) return inferred;

        var Constructor = _vanilla2["default"];
        if (state.opts.loose) Constructor = _loose2["default"];

        path.replaceWith(new Constructor(path, state.file).run());
      }
    }
  };
};

module.exports = exports["default"];